using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Components.Containers;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Driver;
using MudBlazor;
using System.Text.RegularExpressions;
using SortDirection = MudBlazor.SortDirection;

namespace Insight.Web.Pages.Management.Hosts.Network.Interfaces;

[Route(Navigation.Management.Hosts.Network.Interfaces.Index)]
public partial class Index
{
    [Parameter] public string? HostId { get; set; }

    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;
    [Inject] private NavigationManager NavigationManager { get; init; } = default!;

    private TableContainer<HostInterfaceEntity>? Container { get; set; }
    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private string? Search { get; set; }

    protected override async Task OnInitializedAsync()
    {
        if (string.IsNullOrWhiteSpace(HostId) || ObjectId.TryParse(HostId, out var hostId) is false)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        var host = await Database.Host()
            .Find(Builders<HostEntity>
            .Filter
            .Eq(p => p.Id, HostId))
            .FirstOrDefaultAsync(default);

        if (host is null)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        Title = $"Hosts » {host.Name} » Interfaces｜Insight";
        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Hosts", href: Navigation.Management.Hosts.Index));
        Breadcrumbs.Add(new BreadcrumbItem(host.Name, href: Navigation.Management.Hosts.DetailsHref(HostId)));
        Breadcrumbs.Add(new BreadcrumbItem("Interfaces", href: "#", true));
    }

    private async Task<TableData<HostInterfaceEntity>> LoadDataAsync(TableState state)
    {
        try
        {
            var filter = Builders<HostInterfaceEntity>.Filter.Eq(p => p.Host, HostId);

            if (string.IsNullOrWhiteSpace(Search) is false)
            {
                var regex = new BsonRegularExpression(new Regex(Search, RegexOptions.IgnoreCase));
                filter &= Builders<HostInterfaceEntity>.Filter.Regex(x => x.Description, regex) |
                    Builders<HostInterfaceEntity>.Filter.Regex(x => x.Mac, regex) |
                    Builders<HostInterfaceEntity>.Filter.Regex(x => x.Speed, regex) |
                    Builders<HostInterfaceEntity>.Filter.Regex(x => x.Sent, regex) |
                    Builders<HostInterfaceEntity>.Filter.Regex(x => x.Received, regex) |
                    Builders<HostInterfaceEntity>.Filter.Regex(x => x.Status, regex);
            }

            var query = Database.HostInterface()
                .Aggregate()
                .Match(filter)
                //.Lookup<HostInterfaceEntity, HostVirtualMaschineConfigurationEntity, HostVirtualMaschineEntity>(Database.HostsVirtualMaschinesConfigurations(), p => p.DocumentId, p => p.VirtualMaschineId, p => p.Configurations)
                .Sort(state.SortDirection switch
                {
                    SortDirection.Ascending => state.SortLabel switch
                    {
                        "Description" => Builders<HostInterfaceEntity>.Sort.Ascending(p => p.Description),
                        "Mac" => Builders<HostInterfaceEntity>.Sort.Ascending(p => p.Mac),
                        "Speed" => Builders<HostInterfaceEntity>.Sort.Ascending(p => p.Speed),
                        "Sent" => Builders<HostInterfaceEntity>.Sort.Ascending(p => p.Sent),
                        "Received" => Builders<HostInterfaceEntity>.Sort.Ascending(p => p.Received),
                        "Status" => Builders<HostInterfaceEntity>.Sort.Ascending(p => p.Status),
                        _ => null
                    },
                    SortDirection.Descending => state.SortLabel switch
                    {
                        "Description" => Builders<HostInterfaceEntity>.Sort.Descending(p => p.Description),
                        "Mac" => Builders<HostInterfaceEntity>.Sort.Descending(p => p.Mac),
                        "Speed" => Builders<HostInterfaceEntity>.Sort.Descending(p => p.Speed),
                        "Sent" => Builders<HostInterfaceEntity>.Sort.Descending(p => p.Sent),
                        "Received" => Builders<HostInterfaceEntity>.Sort.Descending(p => p.Received),
                        "Status" => Builders<HostInterfaceEntity>.Sort.Descending(p => p.Status),
                        _ => null
                    },
                    _ => Builders<HostInterfaceEntity>.Sort.Ascending(p => p.Description)
                });

            var countResult = await query.Count().FirstOrDefaultAsync(default);

            return new TableData<HostInterfaceEntity>()
            {
                TotalItems = countResult is null ? 0 : (int)countResult.Count,
                Items = await query.Skip(state.Page * state.PageSize).Limit(state.PageSize).ToListAsync(default)
            };
        }
        catch (Exception)
        {
            Notification.Error(Snackbar);
            return new TableData<HostInterfaceEntity>();
        }
    }
}